/* unity-appinfo-manager.c generated by valac 0.11.3, the Vala compiler
 * generated from unity-appinfo-manager.vala, do not modify */

/*
 * Copyright (C) 2010 Canonical, Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Mikkel Kamstrup Erlandsen <mikkel.kamstrup@canonical.com>
 *
 */
/*
 * IMPLEMENTATION NOTE:
 * We want the generatedd C API to be nice and not too Vala-ish. We must
 * anticipate that place daemons consuming libunity will be written in
 * both Vala and C.
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>


#define UNITY_TYPE_APP_INFO_MANAGER (unity_app_info_manager_get_type ())
#define UNITY_APP_INFO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UNITY_TYPE_APP_INFO_MANAGER, UnityAppInfoManager))
#define UNITY_APP_INFO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UNITY_TYPE_APP_INFO_MANAGER, UnityAppInfoManagerClass))
#define UNITY_IS_APP_INFO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UNITY_TYPE_APP_INFO_MANAGER))
#define UNITY_IS_APP_INFO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UNITY_TYPE_APP_INFO_MANAGER))
#define UNITY_APP_INFO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UNITY_TYPE_APP_INFO_MANAGER, UnityAppInfoManagerClass))

typedef struct _UnityAppInfoManager UnityAppInfoManager;
typedef struct _UnityAppInfoManagerClass UnityAppInfoManagerClass;
typedef struct _UnityAppInfoManagerPrivate UnityAppInfoManagerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
typedef struct _UnityAppInfoManagerLookupAsyncData UnityAppInfoManagerLookupAsyncData;

struct _UnityAppInfoManager {
	GObject parent_instance;
	UnityAppInfoManagerPrivate * priv;
};

struct _UnityAppInfoManagerClass {
	GObjectClass parent_class;
};

struct _UnityAppInfoManagerPrivate {
	GeeMap* appinfo_by_id;
	GeeMap* monitors;
	GeeMap* categories_by_id;
};

struct _UnityAppInfoManagerLookupAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	UnityAppInfoManager* self;
	gchar* id;
	GAppInfo* result;
	gboolean _tmp0_;
	gpointer _tmp1_;
	gsize data_size;
	gint data_length1;
	gint _data_size_;
	guint8* data;
	GFileInputStream* input;
	gboolean _tmp2_;
	GFile* _tmp3_;
	GFile* f;
	GFileInputStream* _tmp4_;
	GFileInputStream* _tmp5_;
	GFileInputStream* _tmp6_;
	GFile* _tmp7_;
	GFile* dir;
	gchar* _tmp8_;
	gchar* dir_uri;
	gboolean _tmp9_;
	GFileMonitor* _tmp10_;
	GFileMonitor* monitor;
	GError * ioe;
	gchar* _tmp11_;
	gchar* path;
	GFileInputStream* _tmp12_;
	GFileInputStream* _tmp13_;
	GFileInputStream* _tmp14_;
	guint8* _tmp15_;
	gint _tmp16_;
	gsize _tmp17_;
	GError * e;
	GKeyFile* _tmp18_;
	GKeyFile* keyfile;
	GError * ee;
	GDesktopAppInfo* _tmp19_;
	GDesktopAppInfo* appinfo;
	GError * _inner_error_;
};


static gpointer unity_app_info_manager_parent_class = NULL;
static UnityAppInfoManager* unity_app_info_manager_singleton;
static UnityAppInfoManager* unity_app_info_manager_singleton = NULL;

GType unity_app_info_manager_get_type (void) G_GNUC_CONST;
#define UNITY_APP_INFO_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), UNITY_TYPE_APP_INFO_MANAGER, UnityAppInfoManagerPrivate))
enum  {
	UNITY_APP_INFO_MANAGER_DUMMY_PROPERTY
};
static UnityAppInfoManager* unity_app_info_manager_new (void);
static UnityAppInfoManager* unity_app_info_manager_construct (GType object_type);
gchar** unity_io_get_system_data_dirs (int* result_length1);
static void unity_app_info_manager_on_dir_changed (UnityAppInfoManager* self, GFileMonitor* mon, GFile* file, GFile* other_file, GFileMonitorEvent e);
static void _unity_app_info_manager_on_dir_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
UnityAppInfoManager* unity_app_info_manager_get_instance (void);
GAppInfo* unity_app_info_manager_lookup (UnityAppInfoManager* self, const gchar* id);
GeeList* unity_app_info_manager_get_categories (UnityAppInfoManager* self, const gchar* id);
static void unity_app_info_manager_lookup_async_data_free (gpointer _data);
void unity_app_info_manager_lookup_async (UnityAppInfoManager* self, const gchar* id, GAsyncReadyCallback _callback_, gpointer _user_data_);
GAppInfo* unity_app_info_manager_lookup_finish (UnityAppInfoManager* self, GAsyncResult* _res_, GError** error);
static gboolean unity_app_info_manager_lookup_async_co (UnityAppInfoManagerLookupAsyncData* data);
static void unity_app_info_manager_lookup_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void unity_io_open_from_data_dirs (const gchar* filename, GAsyncReadyCallback _callback_, gpointer _user_data_);
GFileInputStream* unity_io_open_from_data_dirs_finish (GAsyncResult* _res_, GError** error);
void unity_io_read_stream_async (GInputStream* input, gint io_priority, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_io_read_stream_finish (GAsyncResult* _res_, guint8** data, int* data_length1, gsize* size, GError** error);
void unity_app_info_manager_clear (UnityAppInfoManager* self);
static void g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void unity_app_info_manager_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static void _unity_app_info_manager_on_dir_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
	unity_app_info_manager_on_dir_changed (self, _sender, file, other_file, event_type);
}


static UnityAppInfoManager* unity_app_info_manager_construct (GType object_type) {
	UnityAppInfoManager * self = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GeeMap* _tmp1_;
	GeeHashMap* _tmp2_ = NULL;
	GeeMap* _tmp3_;
	GeeHashMap* _tmp4_ = NULL;
	GeeMap* _tmp5_;
	gint _tmp6_;
	gchar** _tmp7_ = NULL;
	GError * _inner_error_ = NULL;
	self = (UnityAppInfoManager*) g_object_new (object_type, NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_APP_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_str_hash, g_str_equal, NULL);
	_tmp1_ = (GeeMap*) _tmp0_;
	_g_object_unref0 (self->priv->appinfo_by_id);
	self->priv->appinfo_by_id = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_str_hash, g_str_equal, NULL);
	_tmp3_ = (GeeMap*) _tmp2_;
	_g_object_unref0 (self->priv->categories_by_id);
	self->priv->categories_by_id = _tmp3_;
	_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_APP_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_str_hash, g_str_equal, NULL);
	_tmp5_ = (GeeMap*) _tmp4_;
	_g_object_unref0 (self->priv->monitors);
	self->priv->monitors = _tmp5_;
	_tmp7_ = unity_io_get_system_data_dirs (&_tmp6_);
	{
		gchar** path_collection;
		int path_collection_length1;
		int path_it;
		path_collection = _tmp7_;
		path_collection_length1 = _tmp6_;
		for (path_it = 0; path_it < _tmp6_; path_it = path_it + 1) {
			gchar* _tmp8_;
			gchar* path;
			_tmp8_ = g_strdup (path_collection[path_it]);
			path = _tmp8_;
			{
				gchar* _tmp9_ = NULL;
				gchar* _tmp10_;
				GFile* _tmp11_ = NULL;
				GFile* _tmp12_;
				GFile* dir;
				GFileMonitor* _tmp13_ = NULL;
				GFileMonitor* monitor;
				gchar* _tmp14_ = NULL;
				gchar* _tmp15_;
				_tmp9_ = g_build_filename (path, "applications", NULL);
				_tmp10_ = _tmp9_;
				_tmp11_ = g_file_new_for_path (_tmp10_);
				dir = (_tmp12_ = _tmp11_, _g_free0 (_tmp10_), _tmp12_);
				_tmp13_ = g_file_monitor_directory (dir, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
				monitor = _tmp13_;
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_IO_ERROR) {
						goto __catch0_g_io_error;
					}
					_g_object_unref0 (dir);
					_g_free0 (path);
					path_collection = (_vala_array_free (path_collection, path_collection_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
				g_signal_connect_object (monitor, "changed", (GCallback) _unity_app_info_manager_on_dir_changed_g_file_monitor_changed, self, 0);
				_tmp14_ = g_file_get_uri (dir);
				_tmp15_ = _tmp14_;
				gee_map_set (self->priv->monitors, _tmp15_, monitor);
				_g_free0 (_tmp15_);
				_g_object_unref0 (monitor);
				goto __finally0;
				__catch0_g_io_error:
				{
					GError * e;
					gchar* _tmp16_ = NULL;
					gchar* _tmp17_;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp16_ = g_file_get_uri (dir);
					_tmp17_ = _tmp16_;
					g_warning ("unity-appinfo-manager.vala:64: Error setting up directory monitor on '" \
"%s': %s", _tmp17_, e->message);
					_g_free0 (_tmp17_);
					_g_error_free0 (e);
				}
				__finally0:
				if (_inner_error_ != NULL) {
					_g_object_unref0 (dir);
					_g_free0 (path);
					path_collection = (_vala_array_free (path_collection, path_collection_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
				_g_object_unref0 (dir);
				_g_free0 (path);
			}
		}
		path_collection = (_vala_array_free (path_collection, path_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	return self;
}


static UnityAppInfoManager* unity_app_info_manager_new (void) {
	return unity_app_info_manager_construct (UNITY_TYPE_APP_INFO_MANAGER);
}


/**
     * Get a ref to the singleton AppInfoManager
     */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


UnityAppInfoManager* unity_app_info_manager_get_instance (void) {
	UnityAppInfoManager* result = NULL;
	UnityAppInfoManager* _tmp2_;
	if (unity_app_info_manager_singleton == NULL) {
		UnityAppInfoManager* _tmp0_ = NULL;
		UnityAppInfoManager* _tmp1_;
		_tmp0_ = unity_app_info_manager_new ();
		_tmp1_ = _tmp0_;
		_g_object_unref0 (unity_app_info_manager_singleton);
		unity_app_info_manager_singleton = _tmp1_;
	}
	_tmp2_ = _g_object_ref0 (unity_app_info_manager_singleton);
	result = _tmp2_;
	return result;
}


static void unity_app_info_manager_on_dir_changed (UnityAppInfoManager* self, GFileMonitor* mon, GFile* file, GFile* other_file, GFileMonitorEvent e) {
	gchar* _tmp0_ = NULL;
	gchar* desktop_id;
	gchar* _tmp1_ = NULL;
	gchar* path;
	GAppInfo* appinfo;
	gboolean _tmp2_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (mon != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = g_file_get_basename (file);
	desktop_id = _tmp0_;
	_tmp1_ = g_file_get_path (file);
	path = _tmp1_;
	appinfo = NULL;
	_tmp2_ = gee_map_has_key (self->priv->appinfo_by_id, desktop_id);
	if (_tmp2_) {
		GAppInfo* _tmp3_ = NULL;
		GAppInfo* _tmp4_;
		gee_map_unset (self->priv->appinfo_by_id, desktop_id, NULL);
		_tmp3_ = unity_app_info_manager_lookup (self, desktop_id);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (appinfo);
		appinfo = _tmp4_;
		g_signal_emit_by_name (self, "changed", desktop_id, appinfo);
	}
	_tmp5_ = gee_map_has_key (self->priv->appinfo_by_id, path);
	if (_tmp5_) {
		GAppInfo* _tmp6_ = NULL;
		GAppInfo* _tmp7_;
		gee_map_unset (self->priv->appinfo_by_id, path, NULL);
		_tmp6_ = unity_app_info_manager_lookup (self, path);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (appinfo);
		appinfo = _tmp7_;
		g_signal_emit_by_name (self, "changed", path, appinfo);
	}
	_g_object_unref0 (appinfo);
	_g_free0 (path);
	_g_free0 (desktop_id);
}


/**
     * Look up an AppInfo given its desktop id or absolute path. The desktop id
     * is the base filename of the .desktop file for the application including
     * the .desktop extension.
     *
     * If the AppInfo is not already cached this method will do synchronous
     * IO to look it up.
     */
GAppInfo* unity_app_info_manager_lookup (UnityAppInfoManager* self, const gchar* id) {
	GAppInfo* result = NULL;
	gboolean _tmp0_;
	GAppInfo* appinfo;
	GKeyFile* _tmp2_ = NULL;
	GKeyFile* keyfile;
	gboolean _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	_tmp0_ = gee_map_has_key (self->priv->appinfo_by_id, id);
	if (_tmp0_) {
		gpointer _tmp1_ = NULL;
		_tmp1_ = gee_map_get (self->priv->appinfo_by_id, id);
		result = (GAppInfo*) _tmp1_;
		return result;
	}
	appinfo = NULL;
	_tmp2_ = g_key_file_new ();
	keyfile = _tmp2_;
	_tmp3_ = g_str_has_prefix (id, "/");
	if (_tmp3_) {
		GFile* _tmp6_ = NULL;
		GFile* _tmp7_;
		GFile* _tmp8_ = NULL;
		GFile* _tmp9_;
		GFile* dir;
		gchar* _tmp10_ = NULL;
		gchar* dir_uri;
		gboolean _tmp11_;
		g_key_file_load_from_file (keyfile, id, G_KEY_FILE_NONE, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError * e;
			GKeyFile* _tmp4_;
			gboolean _tmp5_ = FALSE;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp4_ = NULL;
			_g_key_file_free0 (keyfile);
			keyfile = _tmp4_;
			if (g_error_matches (e, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
				_tmp5_ = TRUE;
			} else {
				_tmp5_ = g_error_matches (e, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_NOT_FOUND);
			}
			if (!_tmp5_) {
				g_warning ("unity-appinfo-manager.vala:135: Error loading '%s': %s", id, e->message);
			}
			_g_error_free0 (e);
		}
		__finally1:
		if (_inner_error_ != NULL) {
			_g_key_file_free0 (keyfile);
			_g_object_unref0 (appinfo);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = g_file_new_for_path (id);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_file_get_parent (_tmp7_);
		dir = (_tmp9_ = _tmp8_, _g_object_unref0 (_tmp7_), _tmp9_);
		_tmp10_ = g_file_get_uri (dir);
		dir_uri = _tmp10_;
		_tmp11_ = gee_map_has_key (self->priv->monitors, dir_uri);
		if (!_tmp11_) {
			GFileMonitor* _tmp12_ = NULL;
			GFileMonitor* monitor;
			_tmp12_ = g_file_monitor_directory (dir, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
			monitor = _tmp12_;
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch2_g_io_error;
				}
				_g_free0 (dir_uri);
				_g_object_unref0 (dir);
				_g_key_file_free0 (keyfile);
				_g_object_unref0 (appinfo);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			g_signal_connect_object (monitor, "changed", (GCallback) _unity_app_info_manager_on_dir_changed_g_file_monitor_changed, self, 0);
			gee_map_set (self->priv->monitors, dir_uri, monitor);
			g_debug ("unity-appinfo-manager.vala:145: Monitoring extra app directory: %s", dir_uri);
			_g_object_unref0 (monitor);
			goto __finally2;
			__catch2_g_io_error:
			{
				GError * ioe;
				ioe = _inner_error_;
				_inner_error_ = NULL;
				g_warning ("unity-appinfo-manager.vala:147: Error setting up extra app directory m" \
"onitor on '%s': %s", dir_uri, ioe->message);
				_g_error_free0 (ioe);
			}
			__finally2:
			if (_inner_error_ != NULL) {
				_g_free0 (dir_uri);
				_g_object_unref0 (dir);
				_g_key_file_free0 (keyfile);
				_g_object_unref0 (appinfo);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_g_free0 (dir_uri);
		_g_object_unref0 (dir);
	} else {
		gchar* _tmp13_ = NULL;
		gchar* path;
		gchar* full_path;
		gchar* _tmp14_ = NULL;
		_tmp13_ = g_build_filename ("applications", id, NULL, NULL);
		path = _tmp13_;
		full_path = NULL;
		g_key_file_load_from_data_dirs (keyfile, path, &_tmp14_, G_KEY_FILE_NONE, &_inner_error_);
		_g_free0 (full_path);
		full_path = _tmp14_;
		if (_inner_error_ != NULL) {
			goto __catch3_g_error;
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError * e;
			GKeyFile* _tmp15_;
			gboolean _tmp16_ = FALSE;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp15_ = NULL;
			_g_key_file_free0 (keyfile);
			keyfile = _tmp15_;
			if (g_error_matches (e, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
				_tmp16_ = TRUE;
			} else {
				_tmp16_ = g_error_matches (e, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_NOT_FOUND);
			}
			if (!_tmp16_) {
				g_warning ("unity-appinfo-manager.vala:161: Error loading '%s': %s", id, e->message);
			}
			_g_error_free0 (e);
		}
		__finally3:
		if (_inner_error_ != NULL) {
			_g_free0 (full_path);
			_g_free0 (path);
			_g_key_file_free0 (keyfile);
			_g_object_unref0 (appinfo);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_free0 (full_path);
		_g_free0 (path);
	}
	if (keyfile != NULL) {
		GDesktopAppInfo* _tmp17_ = NULL;
		GAppInfo* _tmp18_;
		gsize _tmp19_;
		gchar** _tmp20_ = NULL;
		gint categories_length1;
		gint _categories_size_;
		gchar** _tmp21_;
		gchar** categories;
		GeeArrayList* _tmp22_ = NULL;
		GeeArrayList* cats;
		_tmp17_ = g_desktop_app_info_new_from_keyfile (keyfile);
		_tmp18_ = (GAppInfo*) _tmp17_;
		_g_object_unref0 (appinfo);
		appinfo = _tmp18_;
		_tmp20_ = g_key_file_get_string_list (keyfile, "Desktop Entry", "Categories", &_tmp19_, &_inner_error_);
		_tmp21_ = _tmp20_;
		categories_length1 = _tmp19_;
		_categories_size_ = categories_length1;
		categories = _tmp21_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch4_g_key_file_error;
			}
			_g_key_file_free0 (keyfile);
			_g_object_unref0 (appinfo);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp22_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
		cats = _tmp22_;
		{
			gchar** cat_collection;
			int cat_collection_length1;
			int cat_it;
			cat_collection = categories;
			cat_collection_length1 = categories_length1;
			for (cat_it = 0; cat_it < categories_length1; cat_it = cat_it + 1) {
				gchar* _tmp23_;
				gchar* cat;
				_tmp23_ = g_strdup (cat_collection[cat_it]);
				cat = _tmp23_;
				{
					gee_abstract_collection_add ((GeeAbstractCollection*) cats, cat);
					_g_free0 (cat);
				}
			}
		}
		gee_map_set (self->priv->categories_by_id, id, (GeeList*) cats);
		_g_object_unref0 (cats);
		categories = (_vala_array_free (categories, categories_length1, (GDestroyNotify) g_free), NULL);
		goto __finally4;
		__catch4_g_key_file_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (e);
		}
		__finally4:
		if (_inner_error_ != NULL) {
			_g_key_file_free0 (keyfile);
			_g_object_unref0 (appinfo);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	} else {
		GAppInfo* _tmp24_;
		_tmp24_ = NULL;
		_g_object_unref0 (appinfo);
		appinfo = _tmp24_;
	}
	gee_map_set (self->priv->appinfo_by_id, id, appinfo);
	result = appinfo;
	_g_key_file_free0 (keyfile);
	return result;
}


/**
     * Look up XDG categories for for desktop id or file path @id.
     * Returns null if id is not found.
     * This method will do sync IO if the desktop file for @id is not
     * already cached. So if you are living in an async world you must first
     * do an async call to lookup_async(id) before calling this method, in which
     * case no sync io will be done.
     */
GeeList* unity_app_info_manager_get_categories (UnityAppInfoManager* self, const gchar* id) {
	GeeList* result = NULL;
	GAppInfo* _tmp0_ = NULL;
	GAppInfo* appinfo;
	gpointer _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	_tmp0_ = unity_app_info_manager_lookup (self, id);
	appinfo = _tmp0_;
	if (appinfo == NULL) {
		result = NULL;
		_g_object_unref0 (appinfo);
		return result;
	}
	_tmp1_ = gee_map_get (self->priv->categories_by_id, id);
	result = (GeeList*) _tmp1_;
	_g_object_unref0 (appinfo);
	return result;
}


static void unity_app_info_manager_lookup_async_data_free (gpointer _data) {
	UnityAppInfoManagerLookupAsyncData* data;
	data = _data;
	_g_free0 (data->id);
	_g_object_unref0 (data->result);
	_g_object_unref0 (data->self);
	g_slice_free (UnityAppInfoManagerLookupAsyncData, data);
}


void unity_app_info_manager_lookup_async (UnityAppInfoManager* self, const gchar* id, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UnityAppInfoManagerLookupAsyncData* _data_;
	_data_ = g_slice_new0 (UnityAppInfoManagerLookupAsyncData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, unity_app_info_manager_lookup_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, unity_app_info_manager_lookup_async_data_free);
	_data_->self = _g_object_ref0 (self);
	_data_->id = g_strdup (id);
	unity_app_info_manager_lookup_async_co (_data_);
}


GAppInfo* unity_app_info_manager_lookup_finish (UnityAppInfoManager* self, GAsyncResult* _res_, GError** error) {
	GAppInfo* result;
	UnityAppInfoManagerLookupAsyncData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return NULL;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	result = _data_->result;
	_data_->result = NULL;
	return result;
}


/**
     * Look up an AppInfo given its desktop id or absolute path.
     * The desktop id is the base filename of the .desktop file for the
     * application including the .desktop extension.
     *
     * If the AppInfo is not already cached this method will do asynchronous
     * IO to look it up.
     */
static void unity_app_info_manager_lookup_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	UnityAppInfoManagerLookupAsyncData* data;
	data = _user_data_;
	data->_source_object_ = source_object;
	data->_res_ = _res_;
	unity_app_info_manager_lookup_async_co (data);
}


static gboolean unity_app_info_manager_lookup_async_co (UnityAppInfoManagerLookupAsyncData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	data->_tmp0_ = gee_map_has_key (data->self->priv->appinfo_by_id, data->id);
	if (data->_tmp0_) {
		data->_tmp1_ = NULL;
		data->_tmp1_ = gee_map_get (data->self->priv->appinfo_by_id, data->id);
		data->result = (GAppInfo*) data->_tmp1_;
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	data->data_length1 = 0;
	data->_tmp2_ = g_str_has_prefix (data->id, "/");
	if (data->_tmp2_) {
		data->_tmp3_ = NULL;
		data->_tmp3_ = g_file_new_for_path (data->id);
		data->f = data->_tmp3_;
		data->_state_ = 1;
		g_file_read_async (data->f, G_PRIORITY_DEFAULT, NULL, unity_app_info_manager_lookup_async_ready, data);
		return FALSE;
		_state_1:
		data->_tmp4_ = NULL;
		data->_tmp4_ = g_file_read_finish (data->f, data->_res_, &data->_inner_error_);
		data->_tmp5_ = data->_tmp4_;
		if (data->_inner_error_ != NULL) {
			g_simple_async_result_set_from_error (data->_async_result, data->_inner_error_);
			g_error_free (data->_inner_error_);
			_g_object_unref0 (data->f);
			_g_object_unref0 (data->input);
			data->data = (g_free (data->data), NULL);
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
		data->_tmp6_ = data->_tmp5_;
		_g_object_unref0 (data->input);
		data->input = data->_tmp6_;
		data->_tmp7_ = NULL;
		data->_tmp7_ = g_file_get_parent (data->f);
		data->dir = data->_tmp7_;
		data->_tmp8_ = NULL;
		data->_tmp8_ = g_file_get_uri (data->dir);
		data->dir_uri = data->_tmp8_;
		data->_tmp9_ = gee_map_has_key (data->self->priv->monitors, data->dir_uri);
		if (!data->_tmp9_) {
			data->_tmp10_ = NULL;
			data->_tmp10_ = g_file_monitor_directory (data->dir, G_FILE_MONITOR_NONE, NULL, &data->_inner_error_);
			data->monitor = data->_tmp10_;
			if (data->_inner_error_ != NULL) {
				if (data->_inner_error_->domain == G_IO_ERROR) {
					goto __catch5_g_io_error;
				}
				_g_free0 (data->dir_uri);
				_g_object_unref0 (data->dir);
				_g_object_unref0 (data->f);
				_g_object_unref0 (data->input);
				data->data = (g_free (data->data), NULL);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
				g_clear_error (&data->_inner_error_);
				return FALSE;
			}
			g_signal_connect_object (data->monitor, "changed", (GCallback) _unity_app_info_manager_on_dir_changed_g_file_monitor_changed, data->self, 0);
			gee_map_set (data->self->priv->monitors, data->dir_uri, data->monitor);
			g_debug ("unity-appinfo-manager.vala:243: Monitoring extra app directory: %s", data->dir_uri);
			_g_object_unref0 (data->monitor);
			goto __finally5;
			__catch5_g_io_error:
			{
				data->ioe = data->_inner_error_;
				data->_inner_error_ = NULL;
				g_warning ("unity-appinfo-manager.vala:245: Error setting up extra app directory m" \
"onitor on '%s': %s", data->dir_uri, data->ioe->message);
				_g_error_free0 (data->ioe);
			}
			__finally5:
			if (data->_inner_error_ != NULL) {
				g_simple_async_result_set_from_error (data->_async_result, data->_inner_error_);
				g_error_free (data->_inner_error_);
				_g_free0 (data->dir_uri);
				_g_object_unref0 (data->dir);
				_g_object_unref0 (data->f);
				_g_object_unref0 (data->input);
				data->data = (g_free (data->data), NULL);
				if (data->_state_ == 0) {
					g_simple_async_result_complete_in_idle (data->_async_result);
				} else {
					g_simple_async_result_complete (data->_async_result);
				}
				g_object_unref (data->_async_result);
				return FALSE;
			}
		}
		_g_free0 (data->dir_uri);
		_g_object_unref0 (data->dir);
		_g_object_unref0 (data->f);
	} else {
		data->_tmp11_ = NULL;
		data->_tmp11_ = g_build_filename ("applications", data->id, NULL, NULL);
		data->path = data->_tmp11_;
		data->_state_ = 2;
		unity_io_open_from_data_dirs (data->path, unity_app_info_manager_lookup_async_ready, data);
		return FALSE;
		_state_2:
		data->_tmp12_ = NULL;
		data->_tmp12_ = unity_io_open_from_data_dirs_finish (data->_res_, &data->_inner_error_);
		data->_tmp13_ = data->_tmp12_;
		if (data->_inner_error_ != NULL) {
			g_simple_async_result_set_from_error (data->_async_result, data->_inner_error_);
			g_error_free (data->_inner_error_);
			_g_free0 (data->path);
			_g_object_unref0 (data->input);
			data->data = (g_free (data->data), NULL);
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
		data->_tmp14_ = data->_tmp13_;
		_g_object_unref0 (data->input);
		data->input = data->_tmp14_;
		_g_free0 (data->path);
	}
	if (data->input == NULL) {
		gee_map_set (data->self->priv->appinfo_by_id, data->id, NULL);
		data->result = NULL;
		_g_object_unref0 (data->input);
		data->data = (g_free (data->data), NULL);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	data->_tmp15_ = NULL;
	data->_state_ = 3;
	unity_io_read_stream_async ((GInputStream*) data->input, G_PRIORITY_LOW, NULL, unity_app_info_manager_lookup_async_ready, data);
	return FALSE;
	_state_3:
	unity_io_read_stream_finish (data->_res_, &data->_tmp15_, &data->_tmp16_, &data->_tmp17_, &data->_inner_error_);
	data->data = (g_free (data->data), NULL);
	data->data = data->_tmp15_;
	data->data_length1 = data->_tmp16_;
	data->data_size = data->_tmp17_;
	if (data->_inner_error_ != NULL) {
		goto __catch6_g_error;
	}
	goto __finally6;
	__catch6_g_error:
	{
		data->e = data->_inner_error_;
		data->_inner_error_ = NULL;
		g_warning ("unity-appinfo-manager.vala:273: Error reading '%s': %s", data->id, data->e->message);
		data->result = NULL;
		_g_error_free0 (data->e);
		_g_object_unref0 (data->input);
		data->data = (g_free (data->data), NULL);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	__finally6:
	if (data->_inner_error_ != NULL) {
		g_simple_async_result_set_from_error (data->_async_result, data->_inner_error_);
		g_error_free (data->_inner_error_);
		_g_object_unref0 (data->input);
		data->data = (g_free (data->data), NULL);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	data->_tmp18_ = NULL;
	data->_tmp18_ = g_key_file_new ();
	data->keyfile = data->_tmp18_;
	g_key_file_load_from_data (data->keyfile, (const gchar*) data->data, data->data_size, G_KEY_FILE_NONE, &data->_inner_error_);
	if (data->_inner_error_ != NULL) {
		goto __catch7_g_error;
	}
	goto __finally7;
	__catch7_g_error:
	{
		data->ee = data->_inner_error_;
		data->_inner_error_ = NULL;
		g_warning ("unity-appinfo-manager.vala:284: Error parsing '%s': %s", data->id, data->ee->message);
		data->result = NULL;
		_g_error_free0 (data->ee);
		_g_key_file_free0 (data->keyfile);
		_g_object_unref0 (data->input);
		data->data = (g_free (data->data), NULL);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	__finally7:
	if (data->_inner_error_ != NULL) {
		g_simple_async_result_set_from_error (data->_async_result, data->_inner_error_);
		g_error_free (data->_inner_error_);
		_g_key_file_free0 (data->keyfile);
		_g_object_unref0 (data->input);
		data->data = (g_free (data->data), NULL);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	data->_tmp19_ = NULL;
	data->_tmp19_ = g_desktop_app_info_new_from_keyfile (data->keyfile);
	data->appinfo = data->_tmp19_;
	gee_map_set (data->self->priv->appinfo_by_id, data->id, (GAppInfo*) data->appinfo);
	data->result = (GAppInfo*) data->appinfo;
	_g_key_file_free0 (data->keyfile);
	_g_object_unref0 (data->input);
	data->data = (g_free (data->data), NULL);
	if (data->_state_ == 0) {
		g_simple_async_result_complete_in_idle (data->_async_result);
	} else {
		g_simple_async_result_complete (data->_async_result);
	}
	g_object_unref (data->_async_result);
	return FALSE;
	_g_object_unref0 (data->appinfo);
	_g_key_file_free0 (data->keyfile);
	_g_object_unref0 (data->input);
	data->data = (g_free (data->data), NULL);
	if (data->_state_ == 0) {
		g_simple_async_result_complete_in_idle (data->_async_result);
	} else {
		g_simple_async_result_complete (data->_async_result);
	}
	g_object_unref (data->_async_result);
	return FALSE;
}


void unity_app_info_manager_clear (UnityAppInfoManager* self) {
	g_return_if_fail (self != NULL);
	gee_map_clear (self->priv->appinfo_by_id);
}


static void g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_OBJECT) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void unity_app_info_manager_class_init (UnityAppInfoManagerClass * klass) {
	unity_app_info_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (UnityAppInfoManagerPrivate));
	G_OBJECT_CLASS (klass)->finalize = unity_app_info_manager_finalize;
	/**
	     * Emitted whenever an AppInfo in any of the monitored paths change.
	     * Note that @new_appinfo may be null in case it has been removed.
	     */
	g_signal_new ("changed", UNITY_TYPE_APP_INFO_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_OBJECT, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_APP_INFO);
}


static void unity_app_info_manager_instance_init (UnityAppInfoManager * self) {
	self->priv = UNITY_APP_INFO_MANAGER_GET_PRIVATE (self);
}


static void unity_app_info_manager_finalize (GObject* obj) {
	UnityAppInfoManager * self;
	self = UNITY_APP_INFO_MANAGER (obj);
	_g_object_unref0 (self->priv->appinfo_by_id);
	_g_object_unref0 (self->priv->monitors);
	_g_object_unref0 (self->priv->categories_by_id);
	G_OBJECT_CLASS (unity_app_info_manager_parent_class)->finalize (obj);
}


/**
   * A singleton class that caches GLib.AppInfo objects.
   * Singletons are evil, yes, but this on slightly less
   * so because the exposed API is immutable.
   *
   * To detect when any of the managed AppInfo objects changes, appears,
   * or goes away listen for the 'changed' signal.
   */
GType unity_app_info_manager_get_type (void) {
	static volatile gsize unity_app_info_manager_type_id__volatile = 0;
	if (g_once_init_enter (&unity_app_info_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UnityAppInfoManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) unity_app_info_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UnityAppInfoManager), 0, (GInstanceInitFunc) unity_app_info_manager_instance_init, NULL };
		GType unity_app_info_manager_type_id;
		unity_app_info_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "UnityAppInfoManager", &g_define_type_info, 0);
		g_once_init_leave (&unity_app_info_manager_type_id__volatile, unity_app_info_manager_type_id);
	}
	return unity_app_info_manager_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



